/**
 * apeman bud for guide files.
 * @memberof module:apeman-bud-guide/lib
 * @function setup
 * @param {object} params - Template params.
 * @returns {object} - Coz bud configuration.
 */

"use strict";

const argx = require('argx'),
    fs = require('fs'),
    assert = require('assert'),
    stringcase = require('stringcase'),
    _tmpl = require('./_tmpl');

/** @lends setup */
function setup(params) {
    let args = argx(arguments);
    params = args.shift('object') || {};

    let name = params.name,
        pkg = params.pkg;

    assert(name, 'params.name is required.');
    assert(pkg, 'params.pkg is required.');


    return [].concat(name).map((name, i) => {
        let tmpl = _tmpl(name);
        return {
            force: false,
            mode: '644',
            path: `${_numPrefix(i)} - ${stringcase.spinalcase(name)}.md`,
            tmpl: tmpl,
            data: {
                pkg: pkg,
                name:name,
                params: params
            }
        }
    });
}

function _numPrefix(value) {
    let prefix = String(value);
    while (prefix.length < 2) {
        prefix = '0' + prefix;
    }
    return prefix;
}
module.exports = setup;
